function f = fBinTrap(x, o, trsize)
%
% fBinTrap Trap function for binary populations
%
% Package: HOAtbx

    [N,D] = size(x);
    if (mod(D,trsize)) ~= 0,
        throw(MException('WrongDimensionality'));
    end

    f = zeros(N,1);
    for i = 1:D/trsize,
        f = f + Trap( x(:, ((i-1)*trsize+1):(i*trsize) ) );
    end

    f = D-f;  % To make it minimization problem
end

function f = Trap(x)

    D = size(x,2);
    f = D-sum(x,2)-1;
    f(f==-1) = D;
    
end