function pop = iniPermTSPNN(o, popsize, ncities)

if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose, 
    fprintf('Init Random Permutation: PopSize = %d Cities = %d\n',popsize, ncities);
    fprintf('Initializing');
end

pop = zeros(popsize, ncities);
for i = 1:popsize,
    pop(i,:) = randperm(ncities);
    if o.verbose, fprintf('.'); end
end

if o.verbose, fprintf('done.\n'); end

