function pop = iniRealUniform(o, popsize, dim, bounds)
%
% INIREALUNIFORM Initializes real-valued population randomly with
% uniform distribution in given bounds.
%
if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose, 
    fprintf('Initialization: PopSize = %d   Bitstring length = %d\n',popsize, dim);
end

pop = rand(popsize, dim);
minmat = bounds(1,:);
minmat = minmat(ones(popsize,1),:);
difmat = diff(bounds,1,1);
difmat = difmat(ones(popsize,1),:);

pop = minmat + difmat.*pop;