function x = mutBinSwitchBit(x, o, prob)
%
% MUTBINSWITCHBIT Bit switch mutation of randomly selected bit.
%

if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose, fprintf('Mutation switch bit '); end

if nargin < 3 || isempty(prob),
    prob = 1/size(x,2);
end

i = (rand(size(x)) < prob);
x(i) = 1 - x(i); 

if o.verbose, fprintf('done.\n'); end