scrBinCountOnesLSvsEA.mscrBinCountOnesLSvsEA.mscrEABinCountOnesclear;

bitstringlength = 100;
popsize = 100; % Try to set the population size to 1.
pmut = 1/bitstringlength;

o.verbose = 1;
o.MaxFunEvals = 10000;

figure(2); cla; hold on;
for iter = 1:5,
    
    % Run local search
    xstart = rand(1,bitstringlength)>0.5;
    [xLS,fxLS,histLS] = minLocalSearchFirstImproving(...
        @fBinCountOnes, ...
        xstart, ...
        @mutBinSwitchBit, ...
        {}, ...
        {pmut}, ...
        o);

    % Run EA
    [x, fx, histEA] = minEA(...
        @fBinCountOnes, {}, ...
        @iniBinUniform, {popsize, bitstringlength}, ...
        @selTournament, {popsize}, ...
        @xoverBinUniform, {}, ...
        @mutBinSwitchBit, {pmut}, ...
        @repTournamentOldVsNew, {}, ...
        o);

      
%    [ax,h1,h2] = plotyy(histLS.evals, histLS.fmin, histEA.evals, histEA.fmin, @step, @step);
    step(histLS.evals, histLS.fmin, 'b-');
    step(histEA.evals, histEA.fmin, 'r--');
    drawnow;
end

title('Comparison of LS and EA on Counting Ones problem');
xlabel('evaluations');
ylabel('loss function');
legend('LS','EA');
%ylabel(ax(1),'loss function - LS');
%ylabel(ax(2),'loss function - EA');