clear;

% trapsize = 3; bitstringlength = 42;
 trapsize = 4; bitstringlength = 40;
% trapsize = 5; bitstringlength = 50;

popsize = 200; % Try to set the population size to 1.
pmut = 1/bitstringlength;

o.verbose = 0;
o.MaxFunEvals = 15000;

figure(1); cla; hold on;
for iter = 1:10,
    
    % Run local search
    xstart = rand(1,bitstringlength)>0.5;
    [xLS,fxLS,histLS] = minLocalSearchFirstImproving(...
        @fBinTrap, ...
        xstart, ...
        @mutBinSwitchBit, ...
        {trapsize}, ...
        {pmut}, ...
        o);

    % Run EA
    [x, fx, histEA] = minEA(...
        @fBinTrap, {trapsize}, ...
        @iniBinUniform, {popsize, bitstringlength}, ...
        @selTournament, {popsize, 3}, ...
        @xoverBin1Point, {}, ...
        @mutBinSwitchBit, {pmut}, ...
        @repTournamentOldVsNew, {}, ...
        o);

      
%    [ax,h1,h2] = plotyy(histLS.evals, histLS.fmin, histEA.evals, histEA.fmin, @step, @step);
    step(histLS.evals, histLS.fmin, 'b-');
    step(histEA.evals, histEA.fmin, 'r--');
    drawnow;
end

title('Comparison of LS and EA on Trap problem');
xlabel('evaluations');
ylabel('loss function');
legend('LS','EA');
%ylabel(ax(1),'loss function - LS');
%ylabel(ax(2),'loss function - EA');