% Clear the workspace
clear;

dim = 2;
popsize = 100;
pmut = 0.1;
mutstep = 0.1;
o.verbose = 1;
o.MaxFunEvals = 10000;

bounds = [-2.048 2.048]';
bounds = bounds(:,ones(1,dim));

figure(1); cla; set(gca,'YScale','log'); hold on;

for iter = 1:5,
    xstart = -2.048 + 4.096*rand(1,2);
    [xLS,fxLS,histLS] = minLocalSearchFirstImproving(...
        @fRealRosenbrock, ...
        xstart, ...
        @mutSampleGauss, ...
        {}, ...
        {pmut,mutstep},...
        o);

    % Call the evolutionary algorithm for the fRealRosenbrock objective function.
    [xEA, fxEA, histEA] = minEA(...
        @fRealRosenbrock, {}, ...
        @iniRealUniform, {popsize, dim, bounds}, ...
        @selTournament, {popsize}, ...
        @xoverReal1Point, {}, ...
        @mutSampleGauss, {pmut, mutstep}, ...
        @repTournamentOldVsNew, {}, ...
        o);

%        @xoverReal1Point, {}, ...
%        @xoverRealWeightedAverage, {}, ...

    %    [ax,h1,h2] = plotyy(histLS.iter, histLS.f, histEA.evals, histEA.fmin, @step, @step);
    steplogy(histLS.evals, histLS.fmin, 'b-');
    steplogy(histEA.evals, histEA.fmin, 'r--');
    drawnow;

end

title('Comparison of LS and EA on Rosenbrock problem using real represetnation');
xlabel('evaluations');
ylabel('loss function');
legend('LS','EA');
%ylabel(ax(1),'loss function - LS');
%ylabel(ax(2),'loss function - EA');