function x = xoverBin1Point(xin, o)
%
% XOVERBIN1POINT One point crossover
%
if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose,
    fprintf('1-Point Xover ');
end

[N, D] = size(xin);

x1 = xin(randperm(N),:);
x2 = xin(randperm(N),:);
r = ceil(D*rand(N,1));
x = zeros(N, D);
for i = 1:N,
    x(i,:) = [x1(i,1:r(i)) x2(i,(r(i)+1):end)];
end

if o.verbose, fprintf('done.\n'); end

return;
